/*SELECT conrelid::regclass AS table_name,
       conname AS foreign_key,
       pg_get_constraintdef(oid)
FROM   pg_constraint
WHERE  contype = 'f'
*/

/*SELECT 
    tc.table_name, 
    kcu.column_name, 
    ccu.table_name AS foreign_table_name, 
    ccu.column_name AS foreign_column_name 
FROM 
    information_schema.table_constraints tc 
JOIN 
    information_schema.key_column_usage kcu 
    ON tc.constraint_name = kcu.constraint_name 
JOIN 
    information_schema.constraint_column_usage ccu 
    ON ccu.constraint_name = tc.constraint_name 
WHERE 
    tc.constraint_type = 'FOREIGN KEY';
*/
/*
SELECT table_name
FROM information_schema.tables
WHERE table_schema = 'stud';
*/

SELECT *
FROM information_schema.key_column_usage
WHERE table_schema = 'stud' AND position_in_unique_constraint IS NOT NULL;
/*
SELECT table_name,
       COUNT(position_in_unique_constraint) AS num_foreign_keys
FROM information_schema.key_column_usage
WHERE table_schema = 'stud'
GROUP BY table_name
HAVING COUNT(constraint_name) > 1;
*/
SELECT table_name,
       SUM(CASE WHEN position_in_unique_constraint IS NOT NULL THEN 1 ELSE 0 END) AS num_foreign_keys
FROM information_schema.key_column_usage
WHERE table_schema = 'stud'
GROUP BY table_name
HAVING SUM(CASE WHEN position_in_unique_constraint IS NOT NULL THEN 1 ELSE 0 END) > 1;

SELECT table_name,
       COUNT(position_in_unique_constraint) AS num_foreign_keys
FROM information_schema.key_column_usage
WHERE table_schema = 'stud' AND position_in_unique_constraint IS NOT NULL
GROUP BY table_name
HAVING COUNT(position_in_unique_constraint) > 1;
