
CREATE TABLE magr9049.Aukcionas (
  Aukciono_id SERIAL NOT NULL,
  Vedejo_id INTEGER NOT NULL,
  Pavadinimas VARCHAR(64) NOT NULL,
  Pradzios_laikas TIMESTAMP NOT NULL,
  Pabaigos_laikas TIMESTAMP NOT NULL
  CONSTRAINT TinkamasLaikas
  CHECK (Pabaigos_laikas > Pradzios_laikas),
  Vieta VARCHAR(64) DEFAULT 'Nežinoma',
  PRIMARY KEY (Aukciono_id)
);

CREATE TABLE magr9049.Vedejas (
   Vedejo_id SERIAL NOT NULL,
   Vardas VARCHAR(16) NOT NULL,
   Pavarde VARCHAR(16) NOT NULL,
   Telefono_numeris INTEGER
   CONSTRAINT TeigiamasSkaicius
   CHECK (Telefono_numeris > 0),
   PRIMARY KEY (Vedejo_id)
);

CREATE TABLE magr9049.Dalyvis (
   Dalyvio_id SERIAL NOT NULL,
   Vardas VARCHAR(16) NOT NULL,
   Pavarde VARCHAR(16) NOT NULL,
   PRIMARY KEY (Dalyvio_id)
);

CREATE TABLE magr9049.Aukciono_dalyvis (
   Aukciono_id INTEGER,
   Dalyvio_id INTEGER,
   PRIMARY KEY (Aukciono_id, Dalyvio_id),
   FOREIGN KEY (Aukciono_id) REFERENCES magr9049.Aukcionas(Aukciono_id)
   ON DELETE CASCADE ON UPDATE RESTRICT,
   FOREIGN KEY (Dalyvio_id) REFERENCES magr9049.Dalyvis(Dalyvio_id)
   ON DELETE CASCADE ON UPDATE RESTRICT
);

CREATE TABLE magr9049.Daiktas (
   Daikto_id SERIAL NOT NULL,
   Aukciono_id INTEGER,
   Pavadinimas VARCHAR(64),
   Kaina INTEGER,
   Yra_parduotas BOOLEAN
   DEFAULT FALSE
   CONSTRAINT TinkamasBoolean
   CHECK (Yra_parduotas = TRUE OR Yra_parduotas = FALSE),
   PRIMARY KEY (Daikto_id),
   FOREIGN KEY (Aukciono_id) REFERENCES magr9049.Aukcionas(Aukciono_id)
   ON DELETE CASCADE ON UPDATE RESTRICT
);

CREATE TABLE magr9049.Kainos_siulymai (
   Kainos_siulymo_id SERIAL NOT NULL,
   Dalyvio_id INTEGER,
   Daikto_id INTEGER,
   Suma INTEGER
   DEFAULT 1
   CONSTRAINT TeigiamasSkaicius
   CHECK (Suma > 0),
   Yra_laimetojas BOOLEAN
   DEFAULT FALSE
   CONSTRAINT TinkamasBoolean
   CHECK (Yra_laimetojas = TRUE OR Yra_laimetojas = FALSE),
   PRIMARY KEY (Kainos_siulymo_id),
   FOREIGN KEY (Dalyvio_id) REFERENCES magr9049.Dalyvis(Dalyvio_id)
   ON DELETE CASCADE ON UPDATE RESTRICT,
   FOREIGN KEY (Daikto_id) REFERENCES magr9049.Daiktas(Daikto_id)
   ON DELETE CASCADE ON UPDATE RESTRICT
);
