-- Trigeris ir funkcija patikrinti ar kainos pasiulymas yra didesnis negu daikto kaina
CREATE OR REPLACE FUNCTION Patikrinti_Kainos_Siulyma()
RETURNS TRIGGER AS $$
BEGIN
  IF (
    SELECT NEW.Suma
  ) <= (
    SELECT Kaina
    FROM magr9049.Daiktas
    WHERE Daikto_id = NEW.Daikto_id
  ) THEN
    RAISE EXCEPTION 'Kainos siulymas turi buti didesnis negu dabartine kaina.';
  ELSE
    -- Pakeisti kaina
    UPDATE magr9049.Daiktas
    SET Kaina = NEW.Suma
    WHERE Daikto_id = NEW.Daikto_id;
  END IF;

  RETURN NEW;
END;
$$ LANGUAGE PLPGSQL;

CREATE TRIGGER Kainos_Siulymo_Trigeris
BEFORE INSERT OR UPDATE ON magr9049.Kainos_siulymai
FOR EACH ROW EXECUTE FUNCTION Patikrinti_Kainos_Siulyma();

-- Trigeris ir funkcija pakeisti daikto pardavimo bukle
CREATE OR REPLACE FUNCTION Atnaujinti_Daikto_Busena()
RETURNS TRIGGER AS $$
BEGIN
    IF NEW.Yra_laimetojas = TRUE THEN
        IF (SELECT Yra_parduotas FROM magr9049.Daiktas WHERE Daikto_id = NEW.Daikto_id) = TRUE THEN
            RAISE EXCEPTION 'Daiktas jau yra parduotas!';
        ELSE
            UPDATE magr9049.Daiktas
            SET Yra_parduotas = TRUE
            WHERE Daikto_id = NEW.Daikto_id;
        END IF;
    END IF;
    /*IF NEW.Yra_laimetojas = TRUE THEN
        UPDATE magr9049.Daiktas
        SET Yra_parduotas = TRUE
        WHERE Daikto_id = NEW.Daikto_id;
    END IF;*/

    RETURN NEW;
END;
$$ LANGUAGE PLPGSQL;

CREATE TRIGGER Atnaujinti_Daikto_Busena_Trigeris
BEFORE INSERT OR UPDATE ON magr9049.Kainos_siulymai
FOR EACH ROW
EXECUTE FUNCTION Atnaujinti_Daikto_Busena();

-- Trigeris ir funkcija patikrinti ar daiktas yra parduotas
CREATE OR REPLACE FUNCTION Patikrinti_Daiktas_Parduotas()
RETURNS TRIGGER AS $$
BEGIN
    IF NEW.Yra_parduotas = TRUE AND NOT EXISTS (
        SELECT 1
        FROM magr9049.Kainos_siulymai ks
        WHERE ks.Daikto_id = NEW.Daikto_id AND ks.Yra_laimetojas = TRUE
    ) THEN
        RAISE EXCEPTION 'Daiktas negali buti parduotas jeigu neturi laimincio kainos pasiulymo.';
    END IF;
    RETURN NEW;
END;
$$ LANGUAGE PLPGSQL;

CREATE TRIGGER Daiktas_Parduotas_Trigeris
BEFORE INSERT OR UPDATE ON magr9049.Daiktas
FOR EACH ROW
EXECUTE FUNCTION Patikrinti_Daiktas_Parduotas();
