CREATE VIEW magr9049.Dalyvauti_aukcionai AS
SELECT
    A.Aukciono_id,
    A.Pavadinimas,
    A.Pradzios_laikas,
    A.Pabaigos_laikas,
    A.Vieta,
    D.Vardas,
    D.Pavarde
FROM
    magr9049.Aukcionas A
JOIN
    magr9049.Aukciono_dalyvis AD ON A.Aukciono_id = AD.Aukciono_id
JOIN
    magr9049.Dalyvis D ON AD.Dalyvio_id = D.Dalyvio_id;

CREATE VIEW magr9049.Aukciono_apzvalga AS
SELECT
    D.Aukciono_id,
    COUNT(Daiktas.Daikto_id),
    AVG(Daiktas.Kaina)
FROM magr9049.Daiktas
JOIN magr9049.Aukcionas D ON Daiktas.Aukciono_id = D.Aukciono_id
GROUP BY D.Aukciono_id;

CREATE MATERIALIZED VIEW magr9049.Brangiausias_aukciono_daiktas AS
SELECT
  A.Aukciono_id,
  A.Pavadinimas AS Aukciono_Pavadinimas,
  D.Daikto_id,
  D.Pavadinimas AS Daikto_Pavadinimas,
  D.Kaina
FROM
  magr9049.Aukcionas A
JOIN
  magr9049.Daiktas D ON A.Aukciono_id = D.Aukciono_id
WHERE
  D.Kaina = (
    SELECT MAX(Kaina)
    FROM magr9049.Daiktas
    WHERE Aukciono_id = A.Aukciono_id
  );
REFRESH MATERIALIZED VIEW magr9049.Brangiausias_aukciono_daiktas;
