WITH negrazintos AS
(SELECT S.Vardas AS vardas, S.Pavarde AS pavarde,
COUNT(E.Nr) AS negrazinti_egzemp
FROM Stud.Skaitytojas S
LEFT JOIN Stud.Egzempliorius E ON S.Nr = E.Skaitytojas
GROUP BY S.Nr, S.Vardas, S.Pavarde),
avg_negrazinti AS (
    SELECT AVG(negrazinti_egzemp) AS avg_count
    FROM negrazintos
)

SELECT N.vardas, N.pavarde, N.negrazinti_egzemp,
ROUND(A.avg_count, 2) AS avg_negrazintos
FROM negrazintos N CROSS JOIN avg_negrazinti A
WHERE N.negrazinti_egzemp > A.avg_count;
